#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include "serial.h"

int Delay(unsigned int Duration)
{
   unsigned long Counter1, Counter2;
   for (Counter1 = 0 ; Counter1 < Duration ; Counter1 ++)
   {
      for (Counter2 = 0 ; Counter2 < 10000 ; Counter2 ++) ;
   }
   return 0;
}

int Sound(int Duration, int Bit)
{
   sbi(PORTC, Bit);
   Delay(Duration*2);
   cbi(PORTC, Bit);
   return(0);
}

void DiDah(char *String)
{
   unsigned int CharCounter;

   for (CharCounter = 0 ; CharCounter < strlen(String) ; CharCounter ++)
   {
      if (String[CharCounter] == '.') Sound(1,2);
      else Sound(3,2);
      Delay(1);
   }
   Delay(2);
}

void Morse(char Character)
{
   switch (Character)
   {
      case 'a':
         DiDah(".-");
         break;
      case 'b':
         DiDah("-...");
         break;
      case 'c':
         DiDah("-.-.");
         break;
      case 'd':
         DiDah("-..");
         break;
      case 'e':
         DiDah(".");
         break;
      case 'f':
         DiDah("..-.");
         break;
      case 'g':
         DiDah("--.");
         break;
      case 'h':
         DiDah("....");
         break;
      case 'i':
         DiDah("..");
         break;
      case 'j':
         DiDah(".---");
         break;
      case 'k':
         DiDah("-.-");
         break;
      case 'l':
         DiDah(".-..");
         break;
      case 'm':
         DiDah("--");
         break;
      case 'n':
         DiDah("-.");
         break;
      case 'o':
         DiDah("---");
         break;
      case 'p':
         DiDah(".--.");
         break;
      case 'q':
         DiDah("--.-");
         break;
      case 'r':
         DiDah(".-.");
         break;
      case 's':
         DiDah("...");
         break;
      case 't':
         DiDah("-");
         break;
      case 'u':
         DiDah("..-");
         break;
      case 'v':
         DiDah("...-");
         break;
      case 'w':
         DiDah(".--");
         break;
      case 'x':
         DiDah("-..-");
         break;
      case 'y':
         DiDah("-.--");
         break;
      case 'z':
         DiDah("--..");
         break;
      case '0':
         DiDah("-----");
         break;
      case '1':
         DiDah(".----");
         break;
      case '2':
         DiDah("..---");
         break;
      case '3':
         DiDah("...--");
         break;
      case '4':
         DiDah("....-");
         break;
      case '5':
         DiDah(".....");
         break;
      case '6':
         DiDah("-....");
         break;
      case '7':
         DiDah("--...");
         break;
      case '8':
         DiDah("---..");
         break;
      case '9':
         DiDah("----.");
         break;
      case '.':
         DiDah(".-.-.-");
         break;
      case ',':
         DiDah("--..--");
         break;
      case '?':
         DiDah("..--..");
         break;
      case ' ':
         Delay(4);
         break;
      default:
         UART_TransmitLine("Unknown character: ");
         UART_TransmitByte(Character);
         UART_TransmitLine("\n\r");
         break;
   }
}

int Init()
{
   outp(0x07, DDRC);
   outp(0x00, PORTC);
   return 0;
}

int main()
{
   unsigned char InputChar;

   UART_Init(51);
   Init();
   sei();

   UART_TransmitLine("Hello\n\r");

   while (1)
   {

      InputChar = UART_ReceiveByte();
      Morse(InputChar);
//      if (InputChar == '1') Sound(3, 0);
//      else if (InputChar == '2') Sound(3,1);
//      else if (InputChar == '3') Sound(3,2);
   }
   return 0;
}
