#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include <avr/eeprom.h>

#define PodType POD_TYPE_LIGHT
#define POD_VAR_URL "http://pel.cs.byu.edu/~sorenson/Thesis/PODs/LED-Light/"

#include "PODDefines.h"
#include "PODIncludes.h"

#include "Serial.h"
#include "Delay.h"

int Init()
{
   outb(DDRB, 0x00);
   outb(DDRC, 0x0F);
   outb(DDRD, 0x00);
   UART_Init(23);
   sei();

   outb(PORTC, 0x0F);

   return(0);
}

void Process_Command_Light()
{
   unsigned char TempChar;

   TempChar = UART_ReceiveByte();
   outb(PORTC, ~(TempChar & 0x0F) & 0x0F);
   UART_TransmitByte(POD_RESPONSE_ACK);
}

void Process_Command_Get_Status()
{
   unsigned char TempChar;

   UART_TransmitByte(POD_RESPONSE_ACK);
   TempChar = inb(PORTC);
   UART_TransmitByte(TempChar);
}

int Process_Command(unsigned int Command)
{
   switch (Command)
   {
      case POD_COMMAND_PING:
         Process_Command_Ping();
         break; 
      case POD_COMMAND_GETTYPE:
         Process_Command_GetType();
         break;
      case POD_COMMAND_GETINFO:
         Process_Command_GetInfo();
         break;
//      case POD_COMMAND_RESET:
//         Process_Command_Reset();
//         break;
      case POD_COMMAND_GETNAME:
         Process_Command_GetName();
         break;
      case POD_COMMAND_SETNAME:
         Process_Command_SetName();
         break;
      case POD_COMMAND_LIGHT_ON:
         Process_Command_Light();
         break;
      case POD_COMMAND_LIGHT_GET_STATUS:
         Process_Command_Get_Status();
         break;
      default:
         Send_NACK();
         break;
   }
   return(0);
}


int main(int argc, char *argv[])
{
   unsigned int Command;
   Init();

//   UART_TransmitLine("Starting\n\r");
   while (1)
   {
      if (UART_Data())
      {
         Command = UART_ReceiveWord();
         Process_Command(Command);
       } /* if UART_Data */
    }
//      outb(PORTC, 0x05);
}
