#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include <avr/eeprom.h>
#include <string.h>
#include "Serial.h"
#include "Sleep.h"
#include "ADC.h"

#define OUTPUT 0

SIGNAL(SIG_OVERFLOW2)
{
}

char SetPWM(unsigned char PWMVal)
{
   outb(OCR2, PWMVal);
   return(0);
}

void SetDirection(char Direction)
{
//   cbi(PORTB, PB1);
//   cbi(PORTB, PB2);

   if (Direction == 3)
   {
      cbi(PORTB, PB1);
      cbi(PORTB, PB2);
   }
   else if (Direction == 1)
   {
      cbi(PORTB, PB1);
      sbi(PORTB, PB2);
   }
   else
   {
      cbi(PORTB, PB2);
      sbi(PORTB, PB1);
   }
}

char SetupPWM()
{
   outb(TCCR2, (1 << WGM20) | (1 << CS20) | (1 << COM20) | (1 << COM21));
   sbi(DDRB, PB1);
   sbi(DDRB, PB2);
   sbi(DDRB, PB3); /* OC2 */
   return(0);
}

char Init()
{
   cli();
   UART_Init(23);
   SetupPWM();
   sei();
   return(0);
}

int main(int argc, char *argv[])
{
   unsigned char PWMVal;
   unsigned char InputChar;
   unsigned char Buffer[100];
   char Enable;
   char Direction;

   Init();
#if OUTPUT
   UART_clr();
   UART_TransmitLine("Starting\n\r");
#endif
   PWMVal = 255;
   Enable = 0;
   Direction = 1;

   SetDirection(Direction);
   SetPWM(PWMVal);
   while (1)
   {
#if OUTPUT
      UART_TransmitLine("PWM: ");
      itoa(PWMVal, Buffer, 10);
      UART_TransmitLine(Buffer);
      UART_TransmitLine(", Direction: ");
      if (Direction) UART_TransmitByte('1');
      else UART_TransmitByte('0');
      UART_TransmitLine(", Enable: ");
      if (Enable) UART_TransmitByte('1');
      else UART_TransmitByte('0');
      UART_TransmitLine("    \r");
#endif

      InputChar = UART_ReceiveByte();
      if ((InputChar >= '0') && (InputChar <= '9'))
      {
         if (InputChar == '0') InputChar = '9' + 1;
         PWMVal = (255/ 10) * (10 - (InputChar - '0'));
      }
      if (InputChar == '`') PWMVal = 255;
/*
      if (InputChar == 's') Enable ^= 1;
      if (InputChar == 'd')
      {
         Direction ^= 1;
         SetPWM(255);
      }
*/
      else if (InputChar == 'f')
      {
         Enable = 1;
         Direction = 1;
      }
      else if (InputChar == 'b')
      {
         Enable = 1;
         Direction = 0;
      }
      else if (InputChar == 's')
      {
         Enable = 0;
         Direction = 0;
      }
      if (!Enable) SetDirection(3);
      else SetDirection(Direction);
      if (Enable) SetPWM(PWMVal);
      else SetPWM(255);
   }
   return(0);
}
