#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include <avr/eeprom.h>
#include "serial.h"

int GetPowerStatus()
{
   unsigned char Data;

   Data = inb(PINC);
   Data &= 0x10;
   if (! Data) return(1);
   return(0);
}

int Init()
{
   UART_Init(51);
   outb(DDRC, 0x01);
//   outb(PINC, 0x10);
   return(0);
}

int PowerOn()
{
   UART_TransmitLine("Power is on\n\r");
   outb(PORTC, 0x00);
}

int PowerOff()
{
   UART_TransmitLine("Power is off\n\r");
   outb(PORTC, 0x01);
}

int main()
{
   int Status, PreviousStatus;
   Init();
   sei();

   Status = GetPowerStatus();

   if (Status) PreviousStatus = 0;
   else PreviousStatus = 1;
   while (1)
   {
      if (Status != PreviousStatus)
      {
         if (Status) PowerOn();
         else PowerOff();
      }
      PreviousStatus = Status;
      Status = GetPowerStatus();
   }
}
