#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include <avr/eeprom.h>
#include "Serial.h"
#include "Delay.h"

int GetPowerStatus()
{
   unsigned char Data;

   Data = inb(PINB);

   if (Data & 0x01) return(0);
   return(1);
//   if (bit_is_set(PINB, 0)) return(1);
//   return(0);
}

int Init()
{
   UART_Init(23);
   outb(DDRB, 0x00);
   outb(DDRC, 0x03);
   return(0);
}

void PowerOn()
{
   UART_TransmitLine("Power is on\n\r");
   outb(PORTC, 0x02);
}

void PowerOff()
{
   UART_TransmitLine("Power is off\n\r");
   outb(PORTC, 0x01);
}

int main()
{
   int Status, PreviousStatus;
   Init();
   sei();

   Status = GetPowerStatus();

   if (Status) PreviousStatus = 0;
   else PreviousStatus = 1;
   while (1)
   {
      if (Status != PreviousStatus)
      {
         if (Status) PowerOn();
         else PowerOff();
      }
      PreviousStatus = Status;
      Status = GetPowerStatus();
   }
}
